SystemOrganization addCategory: #ParcialIvanQuijadaAvila!

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'numFilas numColumnas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!Matriu class methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/5/2012 15:38'!
new: unNombre
	"Matriu quadrada"
	"Crea una matriu de unNombre x unNombre i despres la retorna"
	| mat |
	Transcript show: 'Creaci de la matriu ' , unNombre asString , ' x ' , unNombre asString ; cr.
	mat := super new: unNombre.
	mat initialize: unNombre.
	^ mat! !

!Matriu class methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/5/2012 15:38'!
new: numFilas per: numColumnas 
	"Crea una matriu de numFilas x numColumnas i despres la retorna"
	| mat |
	Transcript show: 'Creaci de la matriu ' , numFilas asString , ' x ' , numColumnas asString ; cr.
	mat := super new: numFilas.
	mat initialize: numFilas per: numColumnas.
	^ mat! !

!Matriu methodsFor: 'accessing' stamp: 'ivanquijada 11/3/2012 19:08'!
at: unParell
	"Retorna el valor que hi ha a la posicio [unParell.x][unParell.y]"
	| fila columna |
	fila := unParell x.
	columna := unParell y.
	^ ((super at: fila) at: columna).! !

!Matriu methodsFor: 'accessing' stamp: 'ivanquijada 11/3/2012 20:36'!
at: unParell put: unValor
	"Guarda a la posicio [unParell.x][unParell.y] el valor unValor. Despres retorna el valor"
	| fila columna |
	fila := unParell x.
	columna := unParell y.
	Transcript show: ('Es guarda ' , unValor asString , ' en [' , unParell x asString , '][' , unParell y asString , ']');cr.
	^ ((super at: fila) at: columna put: unValor).! !

!Matriu methodsFor: 'printing' stamp: 'ivanquijada 11/7/2012 17:23'!
imprime
	"Mostra al transcript la matriu"
	Transcript show: '---------------------------------------';cr.
	1 to: numFilas do: [ :filas | 
						1 to: numColumnas do: [ :columnas |
											Transcript show: (((super at:filas) at: columnas) asString) , ' ' ].
											Transcript show: '';cr].
	Transcript show: '---------------------------------------';cr.! !

!Matriu methodsFor: 'initialize-release' stamp: 'ivanquijada 11/5/2012 15:22'!
initialize: unNombre
	"Guarda a numFilas i numColumnas el valor unNombre ja que es el nombre de files i columnes (matriu quadrada) i inicialitza totes les posicions de la matriu amb el valor 0"
	Transcript show: 'Inicialitzaci de la matriu'; cr.
	numFilas := unNombre.
	numColumnas := unNombre.
	1 to: numFilas do: [ :filas | self add: (Array new: numFilas).
							1 to: numFilas do: [ :columnas | (super at:filas) at: columnas put: 0]].! !

!Matriu methodsFor: 'initialize-release' stamp: 'ivanquijada 11/5/2012 15:20'!
initialize: filas per: columnas
	"Guarda filas i columnas de la matriu a la variable numFilas i  numColumnas respectivament i inicialitza totes les posicions de la matriu amb el valor 0"
	Transcript show: 'Inicialitzaci de la matriu'; cr.
	numFilas := filas.
	numColumnas := columnas.
	1 to: filas do: [ :filas2 | self add: (Array new: columnas).
							1 to: columnas do: [ :columnas2 | (super at:filas2) at: columnas2 put: 0]].! !

!Matriu methodsFor: 'accessing' stamp: 'ivanquijada 11/5/2012 15:24'!
numColumnas
	^ numColumnas! !

!Matriu methodsFor: 'accessing' stamp: 'ivanquijada 11/5/2012 15:25'!
numFilas
	^ numFilas! !

!Matriu methodsFor: 'printing' stamp: 'ivanquijada 11/7/2012 17:32'!
printOn: aStream
	"Imprimeix la matriu"
	1 to: numFilas do: [ :filas |
						1 to: numColumnas do: [ :columnas |
											aStream nextPutAll: (((super at:filas) at: columnas) asString) , ((columnas = numColumnas) ifTrue: [''] ifFalse: [' '])].
											aStream cr].! !

Object subclass: #Pregunta5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!Pregunta5 methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/4/2012 11:27'!
haltIf: aSelector
	| context |
	context := thisContext.
	[context sender isNil] whileFalse: [
							context := context sender.
							(context selector = aSelector) ifTrue: [
													Halt signal 
							]
	].! !

!Pregunta5 methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/4/2012 11:35'!
prova1
	self haltIf: #prova2.
	^ 'prova1'! !

!Pregunta5 methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/4/2012 11:36'!
prova2
	^ (self prova1), 'prova2'! !

Object subclass: #Preguntes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!Preguntes methodsFor: 'Pregunta1' stamp: 'ivanquijada 11/5/2012 15:45'!
solucio1
	"Exemple d'execuci pero provar totes les funcions, a ms a ms de MatriuTest"
	
	| mat1 mat2 x |
	Transcript show: ('MATRIU QUADRADA') ;cr.
	mat1 := Matriu new:3.
	x := mat1 at:(1@1).
	Transcript show: ('El valor a [1][1] s: ' , x asString) ;cr.
	mat1 at:(1@1) put: 5.
	x := mat1 at:(1@1).
	Transcript show: ('Ara el valor a [1][1] s: ' , x asString) ;cr.
	mat1 imprime.
	
	Transcript show: ('MATRIU NO QUADRADA') ;cr.
	mat2 := Matriu new: 3 per: 2.
	x := mat2 at:(1@1).
	Transcript show: ('El valor a [1][1] s: ' , x asString) ;cr.
	mat2 at:(1@1) put: 5.
	x := mat2 at:(1@1).
	Transcript show: ('El valor a [1][1] s: ' , x asString) ;cr.
	mat2 imprime.! !

!Preguntes methodsFor: 'Pregunta2' stamp: 'ivanquijada 11/9/2012 20:09'!
solucio2
"
Introspecci:
L'introspecci s l'habilitat d'un programa d'observar, i per tant raonar, sobre el seu propi estat. s implementada en llenguatge com Smalltalk o Java perqu disposes d'eines per a conixer la classe d'un objecte, els seus atributs, els seus mtodes, etc. En canvi, en llenguatge com C no existeix.

Intercessi:
L'intercessi s l'habilitat d'un programa de modificar el seu propi estat o d'alterar la seva prpia interpretaci o significat.

Reificaci:
Tant l'introspecci i l'intercessi requereixen d'un mecanisme per codificar l'estat de l'execuci com a dades. Proporcionar aquest estat s'anomena reificaci.

Ni Smalltalk ni Java sn reflexius del tot per, qui ms s'acosta, s Smalltalk perqu permet molt ms que Java la manipulaci de dades. Smalltalk permet la reflexi estructural i de comportament, i Java noms reflexi estructural. A ms a ms, la reflexi en Smalltalk s molt ms simple i fcil de fer.
"! !

!Preguntes methodsFor: 'Pregunta3' stamp: 'ivanquijada 11/9/2012 20:11'!
solucio3
"
Tant Java com Smalltalk sn llenguatges on les classes sn objectes, aquestes classes sn instancies de les metaclasses. La metaclasse s una classe amb instancia classe. s a dir, els objectes sn instancies de una classe i les classes sn instancies de una metaclasse. Cada classe t la seva prpia metaclasse. Guarden les variables de classe (l'estructura, no el valor) i tamb guarden mtodes de classe com per exemple new.

En Java, la metaclasse es denomina amb el nom de Class, es troben al paquet java.lang i, com totes les classes de Java, estn a la classe Object. Noms hi ha una nica instncia per a tots els objectes. Es poden accedir a les instancies de la classe Class i executar els mtodes definits. Aix et permet la reflexi.

En Smalltalk, cada classe s l'nica instncia de la seva metaclasse, no com en Java que noms hi ha una instncia de la metaclasse per a tots els objectes.
Per exemple: classe: Prova -> metaclasse: Prova class
Les metaclasses es construeixen implcitament quan es creen les classes.

Java s un sistema de tres nivells segons la relaci entre objectes, classes i metaclasses. Tots els objectes son instancies d'una classe i totes les classes son instancies d'una metaclasse. La metaclasse tamb s una class, llavors s una instancia de si mateixa. Existeixen dos tipus d'elements en el llenguatge, els objectes i les classes.

En canvi, Smalltalk s un sistema de cinc nivells: objectes, classes, classes de classes, metaclasses y classes de metaclasses. Encara que realment existeixen tres tipus d'elements: objectes, classes i metaclasses.

Respecte el disseny del llenguatge, en Smalltalk s'ha fet que MetaClass sigui instncia de MetaClassClass, i aquesta de MetaClass. En Java tenim la metaclasse que s instncia de si mateixa.
"! !

!Preguntes methodsFor: 'Pregunta4' stamp: 'ivanquijada 11/9/2012 20:12'!
solucio4
"
Respecte a thisContext (avaluat dins) de m, on retorna ^expressi ?
Respecte a thisContext, ^expressi retorna al sender de thisContext del mtode m.

I si el que passa s que dins d'aquest mateix mtode m el que s'avalua s un bloc que cont ^expressi ?
En aquest cas, el bloc es reifica en thisContext com un altre mtode diferent de m. Per tant, ^expressi retorna al sender del thisContext d'aquest altre mtode, s a dir, del que ha creat el bloc.

De quina classe sn instncies els elements de la pila d'execuci que reifica thisContext ?
Els elements de la pila d'execuci que reifica thisContext sn de la classe MethodContext.
"! !

!Preguntes methodsFor: 'Pregunta5' stamp: 'ivanquijada 11/6/2012 12:13'!
solucio5
	"La implementaci de haltIf es troba a la classe Pregunta5
	Pregunta5TestProva1 s l'execuci de prova1 on no ha de saltar el halt
	Pregutna5TestProva2 s l'execuci de prova2 on si s'ha d'aturar
	
	Per comprovar que funciona sense utilitzar els Test es pot fer aix:
	Transcript show: (Pregunta5 new prova1).			->		on surtir directament 'prova1'
	Transcript show: (Pregunta5 new prova2).			->		on surtir la finestra de Halt, i polsant Proceed finalitzar l'execuci mostrant 'prova1prova2'	"! !

!Preguntes methodsFor: 'Pregunta6' stamp: 'ivanquijada 11/9/2012 20:14'!
solucio6
	"Codi Java de la funci haltIf
	
	Aqu nomes he posat el codi de la funci haltIf, per al fitxer Pregunta6.java que et adjuntat hi ha ms codi per provar que funciona correctament.
	
	En el fitxer Preguta6.java hi ha ms comentaris respecte l'execuci i el que ha de sortir.
	
	
	public static void haltIf(String x) {
		Throwable t = new Throwable();
		StackTraceElement[] stackTrace = t.getStackTrace();
		for (int i = 0; i < stackTrace.length; ++i) {
			StackTraceElement ste = stackTrace[i];
			String res = ste.getMethodName();
			if (res.equals(x)) {
				/*
				 * Aqu s'hauria d'executar el Debugger
				 * En Smalltalk seria aix: Halt signal.
				 * En Java no es pot fer i el que fa es escriure un missatge per pantalla i finalitza.
				 */
				System.out.printf(""ALERTA: ATURAT (Halt signal) !!!!\n"");
				System.exit(0);
			}
		}
	}"! !

TestCase subclass: #MatriuTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/3/2012 23:31'!
testAt
	| mat res |
	mat := Matriu new: 5.
	mat at:(1@1) put: 6.
	res := mat at: (1@1).
	self assert: res printString =  '6'.! !

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/7/2012 17:33'!
testAtPut
	| mat |
	mat := Matriu new: 3.
	mat at:(1@1) put: 6.
	mat at:(2@2) put: 7.
	mat at:(3@3) put: 8.
	self assert: mat printString =  ('6 0 0' , Character cr asString, '0 7 0' , Character cr asString , '0 0 8' , Character cr asString).! !

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/7/2012 17:33'!
testPrintOn
	| mat1 mat2 |
	"Matriu quadrada"
	mat1 := (Matriu new: 3) printString.
	self assert: mat1 =  ('0 0 0' , Character cr asString, '0 0 0' , Character cr asString , '0 0 0' , Character cr asString).
	"Matriu no quadrada"
	mat2 := (Matriu new: 3 per: 1) printString.
	self assert: mat2 =  ('0' , Character cr asString , '0' , Character cr asString , '0' , Character cr asString).
	
! !

TestCase subclass: #Pregunta5TestProva1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!Pregunta5TestProva1 methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/4/2012 11:55'!
testHaltIfProva1
	"Acaba sense sortir cap Halt"
	| x |
	x := (Pregunta5 new prova1).
	self assert: x = 'prova1'.! !

TestCase subclass: #Pregunta5TestProva2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialIvanQuijadaAvila'!

!Pregunta5TestProva2 methodsFor: 'as yet unclassified' stamp: 'ivanquijada 11/4/2012 11:56'!
testHaltIfProva2
	"Surt una finestra Halt, i si es dona a Proceed acaba"
	| x |
	x := (Pregunta5 new prova2).
	self assert: x = 'prova1prova2'.! !
